import os
from tempfile import NamedTemporaryFile
            
def send_email(self, To, From , Message):
    import smtplib
    
    if not conf.config.has_key('smtp_server'):
        smtpserver = "or-out.intel.com"
    else:
        smtpserver = conf.config['smtp_server'] 

    AUTHREQUIRED = 0 # if you need to use SMTP AUTH set to 1
    smtpuser = ''  # for SMTP AUTH, set SMTP username here
    smtppass = ''  # for SMTP AUTH, set SMTP password here

    RECIPIENTS = To 
    SENDER = From 
    
    session = smtplib.SMTP(smtpserver)
    if AUTHREQUIRED:
        session.login(smtpuser, smtppass)
    smtpresult = session.sendmail(SENDER, RECIPIENTS, Message)

    if smtpresult:
        errstr = ""
        for recip in smtpresult.keys():
            errstr = """Could not delivery mail to: %s

    Server said: %s
    %s

    %s""" % (recip, smtpresult[recip][0], smtpresult[recip][1], errstr)
        raise smtplib.SMTPException, errstr 
    
        sys.exit('Sending email failed. Please do so using your email client\n')

@cmdln.option('-n', '--nomail', action='store_true',
              help='Do not send email')
@cmdln.option('-m', '--message', metavar='TEXT',
              help='specify message TEXT')
def do_mobsr(self, subcmd, opts, *args):
    """${cmd_name}: Submit a request to the Trunk Project.
    This special command is similar to 'osc sr create'. No need to specify create 
    here however. It will send an email to the mailing list as configured in your
    .oscrc.
    
    You can add to configuration options to make this plugin work for you.
    1. An smtp server (By default or-out.intel.com is used)
    2. The destination mailing list (By default moblin2-commit@linux.intel.com is used)
    
    usage:
          osc mobsr [-m TEXT] 
          osc mobsr [-m TEXT] SOURCEPRJ SOURCEPKG DESTPRJ [DESTPKG]
    Examples:

    ${cmd_usage}
    ${cmd_option_list}
    """

    args = slash_split(args)
    min_args, max_args = 0, 4
    if len(args) < min_args:
        raise oscerr.WrongArgs('Too few arguments.')
    if len(args) > max_args:
        raise oscerr.WrongArgs('Too many arguments.')

    apiurl = conf.config['apiurl']
    if len(args) == 0:
        # try using the working copy at hand
        p = findpacs(os.curdir)[0]
        src_project = p.prjname
        src_package = p.name
        if p.islink():
            dst_project = p.linkinfo.project
            dst_package = p.linkinfo.package
            apiurl = p.apiurl
        else:
            print('Package \'%s\' is not a source link, so I cannot guess the submit target.\n'
                    'Should this package be submitted to Moblin Trunk? (y/N).' % p.name)
            ask = raw_input()
            if len(ask) == 0 or (ask[0] != "y" and ask[0] != "Y"):
                sys.exit("Aborting...")
            else:
                dst_project = "Trunk"
                dst_package = p.name

    elif len(args) >= 3:
        # get the arguments from the commandline
        src_project, src_package, dst_project = args[0:3]
        if len(args) == 4:
            dst_package = args[3]
        else:
            dst_package = src_package
    else:
        raise oscerr.WrongArgs('Incorrect number of arguments.\n\n' \
              + self.get_cmd_help('submitreq'))

    # Make sure we have a .changes file
    changes_file = None
    for f in meta_get_filelist(apiurl, src_project, src_package, expand=True):
        if f.endswith(".changes"):
            if not changes_file:
                changes_file = f
                break

    if not changes_file:
        sys.exit('No changes file, you need to add a file with the changes using the vc command.\n'
                 'The spec file should have no @changlog section.')

    result = create_submit_request(apiurl,
                                   src_project, src_package,
                                   dst_project, dst_package,
                                   opts.message)

    print 'Request has been submitted to %s (request id: %s).' % (dst_project, result)

    if opts.nomail:
		sys.exit('No email sent')
    print "Preparing submission email..."
    r = get_submit_request(apiurl, result)
    diff = str(r);
    new_pkg = None
    
    try:
        diff += server_diff(apiurl,
                            r.dst_project, r.dst_package, None,
                            r.src_project, r.src_package, r.src_rev, False)
    except urllib2.HTTPError, e:
        e.osc_msg = 'Diff not possible'


    user = conf.config['user']
    meta = get_user_meta(apiurl, user)
    root = ET.fromstring(meta)
    realname = root.find('realname').text
    if not realname:
        realname = user
    email = root.find('email').text
    
    commit_list = None
    if not conf.config.has_key('commit_mailing_list'):
        commit_list = "moblin2-commit@linux.intel.com"
    else:
        commit_list = conf.config['commit_mailing_list']
                
    RECIPIENTS = [commit_list]
    SENDER =  email

    custom_message = "Please accept"
    request = "Some text here"
    
    
    submission = """To: %s
From: %s <%s>
Subject: [request %s] Changes to %s in %s

Hi,
I have made the following changes to %s. Please review and accept ASAP.

Thank You,
%s

[This message was auto-generated]

---
    
%s
    
""" %(RECIPIENTS[0],realname, email, result, dst_package, dst_project, dst_package, realname, diff)
   
   
    self.send_email( RECIPIENTS , SENDER , submission)


    # Now verify that it has a diff against the project we are submitting to
    pass
